Subject: Re: link confusion?

From: Brett Lindsley <[email-masked]>
Date: Tue, 29 Mar 2005 05:29:54 -0600

Henry,

The solution I eventually implemented was to include an "id" attribute in
the link. Clients can infer that links with the same id are actually
different views of the same resource. I know this is cheezy but I
am on a tight deadline to prototype.

BTW, I'm not sure why this did not make the syntax list, I was
working from home and sometimes our system flakes.

Brett Lindsley, Motorola Labs

Henry Story wrote:

> Thanks for the note.
>
> These are things that it would be very interesting to clarify with a 
> good OWL
> Ontology for Atom.
>
> I noticed that you post never made it to the Atom-syntax mailing list, 
> btw.
>
> Henry Story
>
> On 27 Mar 2005, at 04:13, Brett Lindsley wrote:
>
>> Henry, I like your thoughts on this. I am working with the Atom link
>> model on a project and found it constraining so I made similar
>> modifications.
>> The two problems I ran into are the following:
>>
>> 1. I wanted to specify different representations of the same resource
>> using a single link. In particular, I wanted a hi-res and low-res
>> representation
>> and allow the end client determine which one it wanted based on
>> size (bandwidth is not aways free). As you indicated, things like
>> the title are the same (description of the link) whereas the size
>> would have been different (description of the resource).
>>
>> 2. An interesting modification I made was under the assumption that
>> network connections may be expensive compared to the content
>> enclosure size. In this case, I wanted to embed the content into the
>> link itself. Allowing an embedded version of the resource and a linked
>> version of the resource allows the end client to have better control 
>> over
>> the version it wants to use. For the rules to encode an embedded
>> object in a link, I used the following:
>>    - If the enclosure is linked, it contains an href attribute; if the
>>      enclosure is embedded, there is *no* href attribute.
>>    - If the MIME type begins with "text", the embedded object is
>>      escape encoded; otherwise, the embedded object is base64
>>      encoded.
>> Of course, the link may also contain various (larger) forms of the
>> resource by using the href along with the embedded object.
>>
>> Brett Lindsley, Motorola Labs
>>
>>
>> ----- Original Message -----
>> From: Henry Story <[email-masked]>
>> Date: Friday, March 25, 2005 2:32 pm
>> Subject: Re: link confusion?
>>
>>>
>>>
>>> On 25 Mar 2005, at 17:36, Henry Story wrote:
>>>
>>>> given the following example xml,
>>>>
>>>>   <entry>
>>>>     ...
>>>>     <link href="http://bblfish.net/blog/page5.html#42"
>>>>           type="text/html"
>>>>           hreflang="en"
>>>>           length="450"
>>>>           title="The html entry"
>>>>           rel="related/>
>>>>    </entry>
>>>> [snip]
>>>> So a better interpretation of the initial xml would be the following
>>>>
>>>> _e1--is-a-> <Entry>
>>>>  |--link-> _link
>>>>           |--to---->_r--is-a-> <Representation>
>>>>           |         |--href--> <"
>>>
>>> target="l">http://bblfish.net/blog/page5.html#42>>           |
>>>    |--type--> "text/html"
>>>
>>>>           |         |--lang--> "en"
>>>>           |         |-length-> 450
>>>>           |-title--> "The html entry"
>>>>           |--rel---> "related"
>>>
>>>
>>> Another interpretation of the original xml which would take into
>>> account the fact that
>>> a link MUST have an href element would be:
>>>
>>> _e1--is-a-> <Entry>
>>>  |--link-> _link
>>>           |--href--><"
>>> target="l">http://bblfish.net/blog/page5.html#42>           |
>>>   |--representation-->_r
>>>           |                             |--type--> "text/html"
>>>           |                             |--lang--> "en"
>>>           |                             |-length-> 450
>>>           |-title--> "The html entry"
>>>           |--rel---> "related"
>>>
>>>
>>> which is saying that a link relates an entry and a resource, and
>>> that
>>> sometimes
>>> it is appropriate to give extra information about representations
>>> of
>>> that resource.
>>>
>>> And so more it would perhaps be clearer for the xml to be stated like
>>> this
>>>
>>> <entry>
>>>     ...
>>>     <link title="The html Entry"
>>>           rel="related"
>>>           href="http://bblfish.net/blog/page5.html#42">
>>>             <representation           
>>>              type="text/html"
>>>             lang="en"
>>>             length="450"/>
>>>     </link>
>>>  </entry>
>>>
>>> I am not saying that that is the answer, just that the it may help
>>> to
>>> make the
>>> distinction clearer somehow between properties of the link and
>>> properties on the
>>> object of the link.
>>>
>>> Henry
>>>
>>>
>